﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Localização
'	Private FusedLocationProvider1 As FusedLocationProvider
	Private LastLocation As Location
	Dim gIntervalo_Envio As Int
	Dim LocationRequest1 As LocationRequest

	Dim Volume_Atual As Float
	Dim Timer_Gps As Timer

	Dim gList_Urls_Voz As List
	Dim gCnt_Urls_Voz As Int

	Dim job_evento ,Job_Confirma  As HttpJob

	Dim Flag_Enconding As Boolean
	
	Dim Timer_Wait_Mp3 As Timer
	
	Dim gDir_Upload, gArq_Upload As String
	Dim gMap_Upload As Map
End Sub

Sub Service_Create
	
	CallSubDelayed(FirebaseMessaging, "SubscribeToTopics")
'	FusedLocationProvider1.Initialize("FusedLocationProvider1")

	Timer_Gps.Initialize ( "Timer_GPS", 30000)
	Timer_Gps.Enabled = False

End Sub

Sub Service_Start (StartingIntent As Intent)
	Timer_Wait_Mp3.Initialize ( "Timer_Wait_Mp3", 1000)
	Timer_Wait_Mp3.Enabled = False
	
	If Starter.Ini_Conf.IsInitialized = False Then 	Starter.Ini_Conf.Initialize(File.DirDefaultExternal,Starter.gIni)
	
	'Verificar se está ativado algum alarme
	If Starter.Ini_Conf.GetSimple ( "executando", "nao") <> "nao" Then
#if log
		Log ( "--------" & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
		Log ( "re-iniciou a localização " & Starter.Ini_Conf.GetSimple ( "executando", "nao") )
		Log ( "--------------------------" )
#End If
		Starter.Ini_Conf.PutSimple ("iniciou","sim")
'		Location_Start
	End If
	
	
End Sub

Sub Service_Destroy

End Sub



Sub Envia_Confirmacao ( pTelefone_Destino As String )
	Dim xDados , xUrl, xTelefone, xSenha, xCod_Mensagem As String
	Job_Confirma.Initialize ( "Job_Confirmacao", Me )
	xTelefone =   Starter.Ini_Conf.GetSimple ( "cod_telefone", "" )
	xSenha = Starter.Ini_Conf.GetSimple ( "cod_senha", "" )

	xCod_Mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem_recebida","")
	xDados =  "comando=sos_confirma_rec&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xCod_Mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha & "&telefone_destino=" & pTelefone_Destino
	xUrl = "http://www.consulta10.com.br/ttm/firebase.php"
#if log
	Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
	Log ( "Dados: " & xDados )
	Log ( "URL: " & xUrl )
	Log ( "--------------------------" )
#end if
	Job_Confirma.PostString( xUrl, xDados  )

End Sub

Sub Envia_Mensagem ( pAcao As String , pStatus As String)
	Dim xDados , xUrl, xTelefone, xSenha As String
	Dim xMultiplos_Destinos, xTextos, xTexto_mensagem, xCod_Mensagem As String

	If Starter.Ini_Conf.IsInitialized = False Then 	Starter.Ini_Conf.Initialize(File.DirDefaultExternal,Starter.gIni)
	
	Job_Confirma.Initialize ( "Job_Envia_Mensagem", Me )
	xTelefone =  Starter.Ini_Conf.GetSimple ( "cod_telefone", "" )
	xSenha = Starter.Ini_Conf.GetSimple ( "cod_senha", "1234" )
	xCod_Mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem", "")
	Select pAcao
		Case "route"
			xTextos = Starter.gTexto_Caminho
			xMultiplos_Destinos = Starter.gTelefones_Caminho
		Case "emergencia"
			xTextos = Starter.gTexto_Emergencia
			xMultiplos_Destinos = Starter.gTelefones_Emergencia
		Case "seguranca"
			xTextos = Starter.gTexto_Seguranca
			xMultiplos_Destinos = Starter.gTelefones_Seguranca
	End Select
	xDados =  "comando=sos_envia_mensagem&distribuidor=1"& "&aplicativo=sos" & "&acao=" & pAcao & "&multiplos_destinos=" & xMultiplos_Destinos  & "&cod_mensagem=" & xCod_Mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha & "&status_mensagem="& pStatus
	xDados = xDados & "&texto_mensagem=" & xTextos & "&tipo_mensagem=" & pAcao
	xUrl = "http://www.consulta10.com.br/ttm/firebase.php"

#if log
	Log ( "--------" & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
	Log ( "Dados: " & xDados )
	Log ( "URL: " & xUrl )
	Log ( "--------------------------" )
#end if
	Job_Confirma.PostString( xUrl, xDados  )

End Sub

Sub enviar_eventos ( pcod_mensagem As String , pArq_Som_Anterior As String)
	Dim xSql, xAcao ,xSeq, xLats, xLongs, xDatas, xTelefone, xSenha, xCod_Mensagem, xDados, xUrl, xMultiplos_Destinos, xDir_Som As String
	Dim xCursor As ResultSet
	If Starter.Ini_Conf.IsInitialized = False Then 	Starter.Ini_Conf.Initialize(File.DirDefaultExternal,Starter.gIni)
	
	'verificar se tem eventos a enviar
	xSql = "Select * from eventos where cod_mensagem ='" & pcod_mensagem & "' and enviado = 'N' order by seq"
	xCursor = Starter.SQL_TTM.ExecQuery( xSql )
	xLats = ""
	xLongs =""
	xDatas = ""
	Do While xCursor.NextRow
		If xLats <> "" Then
			xLats = xLats & ","
			xLongs = xLongs & ","
		End If
		If xDatas <> "" Then
			xDatas = xDatas & ","
		End If
		xLats = xLats & xCursor.GetString ( "latitude" )
		xLongs = xLongs & xCursor.GetString ( "longitude" )
		xDatas = xDatas & xCursor.GetString ( "datab" )
		
		'montar a lista de arquivos para upload
	Loop
	xCursor.Close
	
	xCod_Mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem","")
	xSeq = Starter.Ini_Conf.GetSimple ( "seq_arq_som","")
	xAcao = Starter.Ini_Conf.GetSimple ( "executando", "nao")
	xTelefone = Starter.Ini_Conf.GetSimple ( "cod_telefone", "")
	xSenha = Starter.Ini_Conf.GetSimple ( "cod_senha","")
	Select xAcao
		Case "route"
			xMultiplos_Destinos = Starter.gTelefones_Caminho
		Case "emergencia"
			xMultiplos_Destinos = Starter.gTelefones_Emergencia
		Case "seguranca"
			xMultiplos_Destinos = Starter.gTelefones_Seguranca
	End Select
	
	If xDatas = "" Then
		DateTime.DateFormat = "yyMMddHHmmss"
		xDatas = DateTime.Date (DateTime.Now)
	End If

	xDados =  "comando=sos_envia_evento&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xCod_Mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha
	xDados = xDados & "&latitudes=" & xLats & "&longitudes=" & xLongs & "&multiplos_destinos=" & xMultiplos_Destinos & "&datas=" & xDatas

	xDir_Som = File.Combine ( File.DirDefaultExternal, xCod_Mensagem )

	If File.Exists ( xDir_Som, pArq_Som_Anterior) = False Then
		If xLats <> "" Then
			xUrl = "http://www.consulta10.com.br/ttm/firebase.php"
			job_evento.Initialize ( "Job_Envio_Eventos", Me )
			job_evento.PostString( xUrl, xDados  )
#if log			
			Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
			Log ( "Dados: " & xDados )
			Log ( "URL: " & xUrl )
			Log ( "--------------------------" )
#end if
		Else
#if log
			Log ( "--------" & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
			Log ( "Não enviou nada" & xDados )
			Log ( "URL: " & xUrl )
			Log ( "--------------------------" )
#end if
		End If
	Else
'		Try

			gDir_Upload = xDir_Som
			gArq_Upload = pArq_Som_Anterior
			gMap_Upload =CreateMap("telefone_original": xTelefone , "senha": xSenha, "aplicativo": "sos", "cod_mensagem": xCod_Mensagem, "multiplos_destinos": xMultiplos_Destinos , "cod_sequencia": xSeq , "latitudes": xLats, "longitudes": xLongs, "datas" : xDatas)
			Timer_Wait_Mp3.Enabled = True

'			Dim File_List As List
'			File_List.Initialize
'			Dim fd As MultipartFileData
'			xUrl = "http://www.consulta10.com.br/ttm/upload_sos.php"
'			'pegar todos os arquivos de som gerados e subir
'			
'			fd.Initialize
'			fd.Dir = xDir_Som
'			fd.FileName =  pArq_Som_Anterior.Replace (".wav", ".mp3")
'			'		fd.FileName = "teste.txt"
'			fd.KeyName = "upfile"
'			'		fd.ContentType = "application/octet-stream"
'			fd.ContentType = "audio/mpeg"
'			'		fd.ContentType = "text/plain"
'			File_List.Add(fd)
'			Timer_Wait_Mp3.Enabled = True
'			
'			
'			job_evento.Initialize ("Job_File", Me )
'			'			job_evento.PostMultipart("http://www.consulta10.com.br/heyyou/upload.php", CreateMap("Key1": "Value1", "Key2": "Value2"), Array(fd))
'			job_evento.PostMultipart(xUrl, CreateMap("telefone_original": xTelefone , "senha": xSenha, "aplicativo": "sos", "cod_mensagem": xCod_Mensagem, "multiplos_destinos": xMultiplos_Destinos , "cod_sequencia": xSeq , "latitudes": xLats, "longitudes": xLongs, "datas" : xDatas), File_List)
'		Catch
'			Log(LastException)
'		End Try
'#if log
'		Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
'		Log ( "MultiPartes " & pArq_Som_Anterior )
'		Log ( "URL: " & xUrl )
'		Log ( "--------------------------" )
'#end if
	End If

End Sub

Sub Timer_Wait_Mp3_Tick
	Dim xUrl As String
	
	If Flag_Enconding = False Then
		Timer_Wait_Mp3.Enabled = False
		Try

			Dim File_List As List
			File_List.Initialize
			Dim fd As MultipartFileData
			xUrl = "http://www.consulta10.com.br/ttm/upload_sos.php"
			'pegar todos os arquivos de som gerados e subir
			
			fd.Initialize
			fd.Dir = gDir_Upload
			fd.FileName =  gArq_Upload.Replace (".wav", ".mp3")
			'		fd.FileName = "teste.txt"
			fd.KeyName = "upfile"
			'		fd.ContentType = "application/octet-stream"
			fd.ContentType = "audio/mpeg"
			'		fd.ContentType = "text/plain"
			File_List.Add(fd)

			job_evento.Initialize ("Job_File", Me )
			'			job_evento.PostMultipart("http://www.consulta10.com.br/heyyou/upload.php", CreateMap("Key1": "Value1", "Key2": "Value2"), Array(fd))
			job_evento.PostMultipart(xUrl, gMap_Upload , File_List)
		Catch
			Log(LastException)
		End Try
#if log
		Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
		Log ( "MultiPartes " & gArq_Upload.Replace(".wav", ".mp3") )
		Log ( "URL: " & xUrl )
		Log ( "--------------------------" )
#end if
		
	End If
	
End Sub
'Sub Location_Stop
'	FusedLocationProvider1.Disconnect
'	Timer_Gps.Enabled = False
'End Sub
'
'Sub Location_Start
'	If  FusedLocationProvider1.IsConnected Then
'		FusedLocationProvider1.RequestLocationUpdates(LocationRequest1)
'	Else
'		FusedLocationProvider1.Connect
'	End If
'End Sub
'
'Sub FusedLocationProvider1_ConnectionFailed(ConnectionResult1 As Int)
'	Log("FusedLocationProvider1_ConnectionFailed - " & ConnectionResult1 )
'    
'	'    the FusedLocationProvider ConnectionResult object contains the various CoonectionResult constants
'    
'	Select ConnectionResult1
'		Case FusedLocationProvider1.ConnectionResult.NETWORK_ERROR
'			'    a network error has occurred, this is likely to be a recoverable error
'			'    so try to connect again
'			FusedLocationProvider1.Connect
'		Case FusedLocationProvider1.ConnectionResult.API_UNAVAILABLE
'		Case FusedLocationProvider1.ConnectionResult.CANCELLED
'		Case FusedLocationProvider1.ConnectionResult.INTERNAL_ERROR
'		Case FusedLocationProvider1.ConnectionResult.INVALID_ACCOUNT
'		Case FusedLocationProvider1.ConnectionResult.LICENSE_CHECK_FAILED
'		Case FusedLocationProvider1.ConnectionResult.SERVICE_DISABLED
'		Case FusedLocationProvider1.ConnectionResult.SERVICE_INVALID
'		Case FusedLocationProvider1.ConnectionResult.DEVELOPER_ERROR
'		Case FusedLocationProvider1.ConnectionResult.RESOLUTION_REQUIRED
'		Case FusedLocationProvider1.ConnectionResult.SERVICE_MISSING
'		Case FusedLocationProvider1.ConnectionResult.SERVICE_VERSION_UPDATE_REQUIRED
'		Case Else
'			'    TODO handle other errors
'	End Select
'End Sub
'
'Sub FusedLocationProvider1_ConnectionSuccess
'	Log("FusedLocationProvider1_ConnectionSuccess")
'	LocationRequest1.Initialize
'	LocationRequest1.SetInterval(10000)    '    1000 milliseconds
'	LocationRequest1.SetFastestInterval (1000)
'	LocationRequest1.SetPriority(LocationRequest1.Priority.PRIORITY_HIGH_ACCURACY)
'	LocationRequest1.SetSmallestDisplacement(10)    '    1 meter
'	FusedLocationProvider1.RequestLocationUpdates(LocationRequest1)
'End Sub
'
'Sub FusedLocationProvider1_ConnectionSuspended(SuspendedCause1 As Int)
'	Log("FusedLocationProvider1_ConnectionSuspended- " & SuspendedCause1)
'    
'	'    the FusedLocationProvider SuspendedCause object contains the various SuspendedCause constants
'    
'	Select SuspendedCause1
'		Case FusedLocationProvider1.SuspendedCause.CAUSE_NETWORK_LOST
'			'    TODO take action
'		Case FusedLocationProvider1.SuspendedCause.CAUSE_SERVICE_DISCONNECTED
'			'    TODO take action
'	End Select
'End Sub
'
'Sub FusedLocationProvider1_LocationChanged(Location1 As Location)
'	Dim xData As String
'	
'	Log("FusedLocationProvider1_LocationChanged")
'
'	Dim xLoc, xLoc1 As Location
'	Dim xDist As Double
'	Dim xSql, xDatab, xData, xHora, xMsg, xCod_mensagem, xDir_Som, xArq_Som_Anterior, xPrimeira As String
'	Dim xUrl, xTelefone, xNome, xNome_Destino, xDados, xTelefone_Destino, xSenha, xLat, xLong As String
'	Dim xCursor As ResultSet
'	Dim xStatus, xAcao, xStatus_mens As String
'	Dim xData_Envento, xSeq , xArq_Som As String
'
'	DateTime.DateFormat= "yyMMddHHmmss"
'	If Starter.Ini_Conf.IsInitialized = False Then Starter.Ini_Conf.Initialize(File.DirDefaultExternal,"Ini_SOS")
'	Try
'		If Location1.Accuracy < 30  Then
'			LastLocation=Location1
'			Starter.Ini_Conf.PutObject ( "last_location", Location1 )
'			xData = DateTime.Date ( DateTime.Now )
'			Starter.Ini_Conf.PutObject ( "last_location_date", xData )
'		End If
'
'
'		xCod_mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem", "")
'		DateTime.DateFormat = "yyMMddHHmmss"
'		xDatab =  DateTime.Date( Location1.Time )    'ultima posição lida
'
'		If 	Starter.Ini_Conf.GetSimple ("enviar_posicao", "sim" ) = "sim" Then
'			Starter.Ini_Conf.PutSimple ("enviar_posicao", "nao" )
'			xArq_Som_Anterior = "1.xx"
'			xCod_mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem","")
'			xLat = Location1.Latitude
'			xLong = Location1.Longitude
'			xTelefone = Starter.Ini_Conf.GetSimple ( "cod_telefone", "")
'			xNome = Starter.Ini_Conf.GetSimple ("cod_nome","")
'			xSenha = Starter.Ini_Conf.GetSimple ( "cod_senha","")
'			xTelefone_Destino = Starter.Ini_Conf.GetSimple( "telefone_posicao","")
'
'			xDados =  "comando=sos_envia_posicao&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xCod_mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha & "&nome=" & xNome
'			xDados = xDados & "&latitude=" & xLat & "&longitude=" & xLong & "&telefone_destino=" & xTelefone_Destino & "&datab=" & xDatab
'			xUrl = "http://www.consulta10.com.br/ttm/firebase.php"
'			job_evento.Initialize ( "Job_Envio_Posicao", Me )
'
'			job_evento.PostString( xUrl, xDados  )
'	#if log
'			Log ( "Enviou Posicao : " & xDados)
'	#end if
'			Location_Stop
'			xNome_Destino = Starter.Ini_Conf.GetSimple( "nome_posicao","")
'			xCod_mensagem = "pos" & xTelefone & xDatab
'			DateTime.DateFormat = "dd/MM/yyyy"
'			xData = DateTime.Date ( DateTime.Now)
'			DateTime.DateFormat = "HH:mm:ss"
'			xHora = DateTime.Date ( DateTime.Now)
'			'		DateTime.DateFormat= "yyMMddHHmmss"
'			'		xDatab = DateTime.Date ( DateTime.Now )
'			xMsg = "Solicitação de localização feita por " & xNome_Destino
'			xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab, data_envio, hora_envio, datab, data_leitura, hora_leitura, datab_leitura, status, send_receive, tipo_mensagem, data_final, hora_final, datab_final )"
'			xSql =xSql & "Values ('" & xCod_mensagem & "','" & xTelefone_Destino & "','" & xNome_Destino & "', '" & xMsg & "','" & xDatab  & "','" & xData & "','" & xHora & "','" & xDatab & "','" & xData & "','" & xHora & "','" & xDatab  & "','" & "F"  & "','" & "rec" & "','" & "enviar_posicao"  & "','" & xData & "','" & xHora & "','" & xDatab  & "' )"
'			Try
'				Starter.SQL_TTM.ExecNonQuery ( xSql )
'			Catch
'				Log(LastException)
'			End Try
'			'criar evento
'			xSql = "Insert into eventos ( cod_mensagem, send_receive,  seq, latitude, longitude, datab, enviado) values ( '" & xCod_mensagem.Trim & "', 'send','" & "1" & "', '" & xLat & "', '" & xLong & "', '" & xDatab & "', 'N' )"
'			Try
'				Starter.SQL_TTM.ExecNonQuery ( xSql )
'			Catch
'				Log(LastException)
'			End Try
'			'		Monta_Mensagens ("recebidas")
'		Else
'			Timer_Gps.Enabled = False
'			Timer_Gps.Enabled = True		'reinicia o timer
'			DateTime.DateFormat = "yyMMddHHmmss"
'			xDatab =  DateTime.Date( DateTime.Now )
'			xArq_Som_Anterior = ""
'			xData_Envento = Starter.Ini_Conf.GetSimple( "datab_ultimo_envio", "" )
'			xPrimeira = Starter.Ini_Conf.GetSimple ("iniciou","nao")
'
'			If ( Location1.Accuracy > 0 And Location1.Accuracy < 200 ) Or ( xPrimeira = "sim") Then
'				'verifica se tem mensagem não enviada
'				'			xSql = "Select cod_mensagem, status, enviada, tipo_mensagem from mensagens where cod_mensagem ='" & xCod_mensagem & "' and enviada <> 'S'"
'				'			xCursor = starter.SQL_TTM.ExecQuery( xSql )
'				'			If xCursor.NextRow  Then
'				'Log ( "Reenviou Mensagem; "  & xCod_mensagem )
'				'				xStatus = xCursor.GetString ( "status" )
'				'				xStatus_mens = "ini"
'				'				If xStatus = "F" Then xStatus_mens = "fim"
'				'				xAcao = xCursor.GetString ( "tipo_mensagem" )
'				'				Envia_Mensagem ( xAcao,	xStatus_mens , xCod_mensagem )
'				'			End If
'				'			xCursor.Close
'
'				'		Log(Location1.Latitude & ", " & Location1.Longitude)
'				'		Log ( "Precisão: " & Location1.Accuracy)
'				'		Log ( "Velocidade: " & Location1.Speed )
'				'		DateTime.DateFormat = "yyMMddHHmmss"
'				'		Log ( "Date: " & DateTime.Date( Location1.Time ) )
'				'		Log ( "Time: " & DateTime.Time( Location1.Time ) )
'				'		Log ( "------------------------")
'				xCod_mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem", "")
'				DateTime.DateFormat = "yyMMddHHmmss"
'				xDatab =  DateTime.Date( Location1.Time )
'				'verificar se ultima leitura mais apurada na mesma distancia ou mudou o posicionamento
'				If Starter.Ini_Conf.GetSimple("ultima_latitude", 0) = 10 Then
'					Starter.Ini_Conf.PutSimple ( "ultima_latitude", Location1.Latitude )
'					Starter.Ini_Conf.PutSimple ( "ultima_longitude", Location1.Longitude )
'				End If
'
'				xLoc.Initialize2 ( Starter.Ini_Conf.GetSimple("ultima_latitude", 0), Starter.Ini_Conf.GetSimple("ultima_longitude",0) )
'				xLoc1.Initialize2 ( Location1.Latitude, Location1.Longitude)
'				xDist = xLoc1.DistanceTo ( xLoc)
'				If  (xDist > 20) Or (xPrimeira = "sim" ) Then 'Or ( (xDatab - xData_Envento)  > 500 )  Then
'					'Salva no banco se se movimentou ou é a primeira vez
'					Starter.Ini_Conf.PutSimple ("iniciou","nao")
'					Starter.Ini_Conf.PutSimple ( "ultima_latitude", Location1.Latitude )
'					Starter.Ini_Conf.PutSimple ( "ultima_longitude", Location1.Longitude )
'					'verifica se esta ativo algum servico
'					If Starter.Ini_Conf.GetSimple ( "executando","nao") <> "nao" Then
'						'cria event na tabela e envia ao servidor
'						'cod_evento, tipo_evento, data, hora, datab, latitude, longitude, telfone_origem, telefones_destino )
'						Dim xInt As Int
'						xInt = Starter.Ini_Conf.GetSimple ( "seq_mensagem", 1) + 1
'						xCod_mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem", "")
'						xSql = "Insert into eventos ( cod_mensagem, send_receive, seq, latitude, longitude, datab, enviado ) Values ('" & xCod_mensagem & "' , 'send', '" & xInt  & "' , '" & Location1.Latitude & "' , '" & Location1.Longitude & "' , '" & xDatab & "', 'N')"
'	#if log
'						Log ( "Insere eventos:" & xSql )
'	#end if
'						Try
'							Starter.SQL_TTM.ExecNonQuery ( xSql )
'						Catch
'							Log(LastException)
'						End Try
'						
'						Starter.Ini_Conf.PutSimple ( "seq_mensagem", xInt)
'					End If
'				Else
'	#if log
'					Log ( "Distancia " & xDist )
'	#end if
'				End If
'			End If
'
'			'verificar ultimo envio toda vez que recebe uma localização
'	#if log
'			Log ( "xDatab - xData_Envento  > gIntervalo_Envio : " & ( xDatab - xData_Envento ) & " - " & gIntervalo_Envio )
'	#end if
'			If ( xDatab - xData_Envento  > gIntervalo_Envio ) Or ( xPrimeira = "sim")Then
'				Try
'					Starter.Ini_Conf.PutSimple ( "datab_ultimo_envio",  xDatab  )		'salva nova data de envio
'
'					If Main.recording Then
'						xArq_Som_Anterior = Main.gArq_Som
'					Else
'						xArq_Som_Anterior ="1.xx"
'					End If
'					If Starter.Ini_Conf.GetSimple  ( "executando", "route") <> "route"  Then
'						CallSub(AudioRecord,"StopRecording")  'encerrar antes de troca o nome
'
'						xSeq = Starter.Ini_Conf.GetSimple ( "seq_arq_som", 10) + 1
'						Starter.Ini_Conf.PutSimple ("seq_arq_som", xSeq )
'						'inicia nova gravação
'						Main.gArq_Som = "env_" & xCod_mensagem & "_" & xSeq  & ".wav"
'						Main.gDir_Arq_Som = File.Combine ( File.DirDefaultExternal, xCod_mensagem )
'						
'						CallSub(AudioRecord,"StartRecording")
'						Main.gLista_Arq_Som.Add ( xArq_Som )
'					End If
'				Catch
'					Log(LastException)
'				End Try
'				'			'					xArq_Som_Anterior = "1.xx"
'				enviar_eventos ( xCod_mensagem, xArq_Som_Anterior )
'			End If
'		End If
'
'	Catch
'		Log(LastException)
'	End Try
'
'End Sub
'
'
'Sub Timer_GPS_Tick
'	Location_Start  'solicita uma nova leitura
'	
'End Sub

public Sub JobDone (Job As HttpJob)
	Dim xresp, xCod_Mensagem As String
	Dim Ln As Notification
	Dim xCnt_lat As Int
	Dim xList_Resp, xList_Mensagem,xList_Lat, xList_long, xList_Som, xList_Datab  As List
	Dim xDatab, xSeq, xFlag_Mais, xLat, xLong, xDados, xUrl, xTelefone, xSenha, xarq_som As String
	Dim xCnt As Int
	Dim xSql, xData_Envio, xHora_Envio, xArq, xDir As String
	Dim xList As List



	If Job.Success = True Then
		If Starter.SQL_TTM.IsInitialized = False Then Starter.SQL_TTM.Initialize(Starter.DBFileDir, Starter.DBFileName, True)  'abre ou cria

		Try
			If Job.JobName <> "mp3"  Then
				CallSub ( Main, "Some_Progress" )
				xresp = Job.GetString
				Try
					xresp = Main.SU.DecodeUrl( xresp, "UTF8" )
				Catch
					Log(LastException)
				End Try
				'				xresp = xresp.Replace ("xxx", "%")

#if log			
				Log ( "--------" & Main.gTipo_Produto & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
				Log ("Jobdone: " & Job.JobName & " - " & xresp )
				Log ( "-------------------")
#end if	
			End If

			Select Job.JobName
				'		Case "Job_Indicacao"
				''			ToastMessageShow ( xresp, True )
				'			CallSub2 ( Main, "Back_Indicacao", xresp )
				Case "Job_Registro"
					'				xresp = Job.GetString
					CallSub2 ( Main, "Back_Registro", xresp )
				Case "Job_Token"
					'				xresp = Job.GetString
					Msgbox (xresp, trans.translate("Retorno"))
				Case "Job_File"
					'				xresp = Job.GetString
					If xresp.Contains ( "OK" ) Then
						xCod_Mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem","")
						xSql = "update eventos set enviado ='S' where cod_mensagem ='" & xCod_Mensagem & "'"
						Starter.SQL_TTM.ExecNonQuery ( xSql)
					End If
				Case "Job_Envia_Localizar"
					'				xresp = Job.GetString
					ToastMessageShow (xresp, False)
					'					Msgbox (xresp, "Localizar")
				Case "Job_Solicita_Posicao"
					'				xresp = Job.GetString
					ToastMessageShow (xresp, False)
					'					Msgbox (xresp, "Solicita Posição")
				Case "Job_Envia_Mensagem"
					'				xresp = Job.GetString
					'Salva no banco indicando que a mensagem foi enviada
					'				Log ( "Retorno Mensagem: " & xresp )
					If xresp.Contains ( "OK" ) Then
						xList.Initialize
						xList = Regex.Split ( ";" , xresp )   '0="OK", 1=cod_mensagem
						DateTime.DateFormat = "dd/MM/yyy"
						xData_Envio = DateTime.Date ( DateTime.Now )
						DateTime.DateFormat = "HH:mm:ss"
						xHora_Envio = DateTime.Time ( DateTime.Now )
						xSql = "update mensagens set enviada = 'S', data_envio = '" & xData_Envio & "', hora_envio='" & xHora_Envio & "' where cod_mensagem = '" & xList.Get(1) & "'"
#if log
						Log ( xSql)
#end if	
						Starter.SQL_TTM.ExecNonQuery( xSql)
					End If
					'					ch.Complete
				Case "Job_Confirmacao"
					'				xresp = Job.GetString
					If xresp.SubString2 (0,2) = "OK" Then
						'marca no banco que enviou confirmação
					End If
					Main.gFlag_Enviado_COnfirmacao = True
					'				Msgbox (xresp, "Confirmação")
				Case "Job_Busca_Eventos"
					'				xresp = Job.GetString

					xList_Resp =Regex.Split ("@@", xresp )  'retorna eventos e talvez mensagem inicial  index 0 = evento e index 1=mensagem
					If xList_Resp.Size > 1 Then
						'recebeu a mensagem inicial também
						'"$xcod_mensagem;$xtelefone;$xnome;$xtexto;$xtipo_mensagem;$xdata_envio;$xhora_envio;$xstatus_mensagem";
#if log
						Log ( Main.gTipo_Produto & " - " & "Foi Buscar mensagem")
#end if	
						xList_Mensagem = Regex.Split(";", xList_Resp.Get(1))
						xData_Envio = xList_Mensagem.Get(5)
						xHora_Envio = xList_Mensagem.Get(6)
						xDatab = xData_Envio.SubString2 (8,10) & xData_Envio.SubString2 (3,5) &xData_Envio.SubString2 (0,2) & xHora_Envio.SubString2(0,2)  & xHora_Envio.SubString2(3,5) & xHora_Envio.SubString2(6,8)
						xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab, data_leitura, hora_leitura, datab_leitura, status, send_receive, tipo_mensagem )"
						xSql =xSql & "Values ('" & xList_Mensagem.Get(0) & "','" &  xList_Mensagem.Get(1) & "','" &  xList_Mensagem.Get(2) & "', '" &  xList_Mensagem.Get(3)  & "','" & xDatab  & "','" &  xList_Mensagem.Get(5) & "','" &  xList_Mensagem.Get(6) & "','" & xDatab  & "','" & xList_Mensagem.Get(7)  & "','" & "rec" & "','" &  xList_Mensagem.Get(4)  & "' )"
						Starter.Ini_Conf.PutSImple( xCod_Mensagem, 0)  'inicia a sequencia desta mensagem
						Try
							Starter.SQL_TTM.ExecNonQuery ( xSql )
						Catch
							Log(LastException)
						End Try
					End If
					
					'OK:;$xcod_mensagem;$xlats;$xlongs;$xcodigo;$xdatab;$xurls_voz;$xflag_tem_mais
					xList = Regex.Split(";", xList_Resp.Get(0))
					xFlag_Mais = "0"
					If gList_Urls_Voz.IsInitialized Then
						'						If gList_Urls_Voz.Size > 0 Then
						'							gList_Urls_Voz.Clear
						'						End If
						
					Else
						gList_Urls_Voz.Initialize
					End If
					If xList.Get(0) = "OK:" Then
						'Salvar eventos  vem os campos lats, longs, datas, soms
						xCod_Mensagem =  xList.Get(1)
						Main.gCod_Mensagem_Download = xCod_Mensagem
						xList_Lat = Regex.Split ( ",", xList.Get(2) )
						xList_long = Regex.Split ( ",", xList.Get(3) )
						xSeq = xList.Get(4)
						'					xDatab = xList.Get(5)
						xList_Datab = Regex.Split (",", xList.Get(5) )
						gList_Urls_Voz = Regex.Split (",", xList.Get(6) ) 'Urls_Voz
						xFlag_Mais = xList.Get(7)
						'				xList_Som = Regex.Split ( ",", xlist.Get(4) )
						xCnt = xList_Lat.Size
						Try
							If gList_Urls_Voz.Size > 0  And gList_Urls_Voz.Get(0) <> ""  Then
								'Download os arquivos de voz
								gCnt_Urls_Voz = 0
								Main.gArq_Download =  gList_Urls_Voz.Get(gCnt_Urls_Voz)
								job_evento.Initialize ("mp3", Me)
								job_evento.Download ( "http://www.consulta10.com.br/ttm/voz_sos/" & gList_Urls_Voz.Get(gCnt_Urls_Voz))
								'						job_evento.Download ( "https://consulta10.webseguro.com.br/ttm/voz_sos/" & gList_Urls_Voz.Get(gCnt_Urls_Voz))
								'								job_evento.GetRequest.SetContentType ("audio/mpeg")
								'								job_evento.GetRequest.Timeout = 15000
							End If
						
						
						Catch
							Log(LastException)
						End Try
					End If
					Starter.Ini_Conf.PutSImple( xCod_Mensagem, xSeq)  'atualiza utlimo campo buscado

					If xList_Resp.Size > 1 Then
						Envia_Confirmacao ( xTelefone )
						If Starter.Ini_Conf.getSimple ("background","sim") = "nao" Then
							If 	Starter.Ini_Conf.GetSimple ( "pnl_black_on", "nao") = "nao" Then
							 	CallSub2 ( Main,	"Monta_Mensagens", "recebidas")
							 End If
						End If
					End If
#if log
					Log ( "--------" & Main.gTipo_Produto & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
					Log ("Jobdone: " & Job.JobName & " - " & xresp )
					Log ( "-------------------")
#end if
					If xFlag_Mais = "1" And Starter.Ini_Conf.GetSimple ("background","nao") = "nao" Then
						'Busca mais events
						xTelefone =   Starter.Ini_Conf.GetSimple ( "cod_telefone", "" )
						xSenha = Starter.Ini_Conf.GetSimple ("cod_senha", "")

						xCod_Mensagem = Starter.Ini_Conf.GetSimple ( "cod_mensagem","")
						xDados =  "comando=sos_busca_eventos&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xCod_Mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha
						xDados = xDados & "&seq_evento=" & xSeq
						xUrl = "http://www.consulta10.com.br/ttm/firebase.php"

#if log
						Log ( "Dados novos Eventos: " & xDados )
#end if						
						Job_Confirma.Initialize ( "Job_Busca_Eventos", Me )
						Job_Confirma.PostString( xUrl, xDados  )
					Else
						'						ch.Complete
					End If
					
				Case "Job_Envio_Posicao"
					'				xresp = Job.GetString
					
					If Starter.Ini_Conf.GetSimple ("background","nao") = "nao" Then
						ToastMessageShow (trans.translate("Solicitado sua posição") & Starter.Ini_Conf.GetSimple ("telefone_posicao","") , True )
					End If
				Case "mp3"  'faz o download do arquvio de som
					xArq =	Main.gArq_Download
					xDir = File.Combine ( File.DirDefaultExternal, "voz_rec")
					If xArq.Length > 5 Then
						Dim xOutPut As OutputStream = File.OpenOutPut(xDir, xArq, False)
						File.Copy2(Job.GetInputStream, xOutPut)
						xOutPut.Close
						gCnt_Urls_Voz = gCnt_Urls_Voz + 1
						If gCnt_Urls_Voz < gList_Urls_Voz.Size Then
							'busca a próxima
							Main.gArq_Download = gList_Urls_Voz.Get(gCnt_Urls_Voz)
							job_evento.Initialize ("mp3", Me)
							'						xUrl =  "http://www.consulta10.com.br/ttm/voz_sos/" & gList_Urls_Voz.Get(gCnt_Urls_Voz)
							xUrl = gList_Urls_Voz.Get(gCnt_Urls_Voz)
#if log
							Log ( "* busca som: " & xUrl )
#end if		
							job_evento.Download ("http://www.consulta10.com.br/ttm/voz_sos/" & xUrl )
							'							job_evento.GetRequest.SetContentType ("audio/mpeg")
							'							job_evento.GetRequest.Timeout = 15000
						Else
							CallSub ( Main, "Some_Progress" )
						End If

						'						If Timer_LogOut.IsInitialized = False Then Timer_LogOut.Initialize("Timer_LogOut", 3000)
						'						Timer_LogOut.Enabled = True
					End If
				Case "Job_Sync_Mensagens"
					Dim xNome, xTexto, xData_Final, xHora_Final, xDatab_Final, xStatus_Mensagem, xTipo_Mensagem As String
					'Salva no banco os dados
					'				xresp = Job.GetString
					Dim xList_Resp, xList_Campos As List
					Dim xDatab, xSeq, xFlag_Mais, xLat, xLong, xDados, xUrl, xTelefone, xSenha, xStatus As String
					Dim xCnt As Int
					
					If xresp.Contains ("Er:") Then
						Msgbox ( trans.translate("Nenhuma mensagem encontrada"), trans.translate("Mensagens"))
					Else
						xList_Resp =Regex.Split ("@@", xresp )  'retorna cod_mensagem, telefone, nome, texto, data_envio, hora_envio, status_mensagem, data_final, hora_final, datab_final
						If xList_Resp.Size > 0 Then
							xCnt = 0
							xSql = "delete from mensagens where send_receive = 'rec'"
							Starter.SQL_TTM.ExecNonQuery (xSql)
							Do While xCnt < xList_Resp.Size
								xList_Campos = Regex.Split (",", xList_Resp.Get( xCnt ) )  'posição0 = lat, long, datab, xarq_som
								xCod_Mensagem = xList_Campos.Get (0)
								xTelefone = xList_Campos.Get (1)
								xNome = xList_Campos.Get (2)
								xTipo_Mensagem = xList_Campos.Get (3)
								xTexto = xList_Campos.Get (4)
								xData_Envio = xList_Campos.Get (5)
								xHora_Envio = xList_Campos.Get(6)
								xDatab = xData_Envio.SubString2 (8,10) & xData_Envio.SubString2 (3,5) &xData_Envio.SubString2 (0,2) & xHora_Envio.SubString2(0,2)  & xHora_Envio.SubString2(3,5) & xHora_Envio.SubString2(6,8)
								xStatus_Mensagem = xList_Campos.Get (7)
								If xList_Campos.Size > 8 Then
									xData_Final = xList_Campos.Get (8)
									xHora_Final = xList_Campos.Get (9)
									xDatab_Final = xList_Campos.Get (10)
								Else
									xData_Final = ""
									xHora_Final = ""
									xDatab_Final = ""
								End If

								xStatus = "A"
								If xStatus_Mensagem = "fim" Then
									xStatus = "F"
								End If
								Try
									Starter.SQL_TTM.BeginTransaction
									xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab, data_leitura, hora_leitura, status, send_receive, tipo_mensagem, data_final, hora_final, datab_final )"
									xSql =xSql & "Values ('" & xCod_Mensagem & "','" & xTelefone & "','" & xNome & "','" & xTexto & "','"  & xDatab & "','" & xData_Envio & "','" & xHora_Envio & "','"  & xStatus  & "','" & "rec" & "','" & xTipo_Mensagem  & "','" & xData_Final & "','" & xHora_Final & "','" & xDatab_Final  & "' )"
#if log
									Log ( "--------" & Main.gTipo_Produto & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
									Log ("Sincronizados: " & xSql )
									Log ( "-------------------")
#end if
									Starter.SQL_TTM.ExecNonQuery(xSql)
									Starter.SQL_TTM.TransactionSuccessful
								Catch
									Log(LastException)
								End Try
								Starter.SQL_TTM.EndTransaction
								xCnt = xCnt + 1
							Loop
							If Starter.Ini_Conf.GetSimple ("background","sim") = "nao" Then 
								If 	Starter.Ini_Conf.GetSimple ( "pnl_black_on", "nao") = "nao" Then
									CallSub2 ( Main,	"Monta_Mensagens" ,"recebidas")
								End If
								
							End If
						End If
					End If

				Case "Job_Sync_Eventos"
					'Salva no banco os dados
					'				xresp = Job.GetString
					Dim xList_Resp, xList_Campos As List
					Dim xDatab, xSeq, xFlag_Mais, xLat, xLong, xDados, xUrl, xTelefone, xSenha As String
					Dim xCnt As Int
					
					xList_Resp =Regex.Split ("@@", xresp )  'retorna eventos e talvez mensagem inicial  index 0 = evento e index 1=mensagem
					If xList_Resp.Size > 1 Then
						xCnt = 1
						xCod_Mensagem = xList_Resp.Get(0)
						xSql = "delete from eventos where cod_mensagem = '" & xCod_Mensagem & "'"
						Starter.SQL_TTM.ExecNonQuery (xSql)
						xList_Lat.Initialize
						xList_long.Initialize
						If gList_Urls_Voz.IsInitialized = False Then gList_Urls_Voz.Initialize
						'						If gList_Urls_Voz.Size > 0  And gList_Urls_Voz.Get(0) <> ""  Then
						'							gList_Urls_Voz.Clear
						'						End If
						
						Do While xCnt < xList_Resp.Size
							xList_Campos = Regex.Split (";", xList_Resp.Get( xCnt ) )  'posição0 = lat, long, datab, xarq_som
							xLat = xList_Campos.Get (0)
							xLong = xList_Campos.Get(1)
							xDatab = xList_Campos.Get(2)
							If xList_Campos.Size >3 Then
								xarq_som = xList_Campos.Get(3)
								xList_Som = Regex.Split ( ",", xarq_som )
							Else
								xarq_som = ""
								xList_Som.Initialize
							End If
							
							'nos campos lat e long podem ter mais de um lancamento
							xList_Lat = Regex.Split ( ",", xLat )
							xList_long = Regex.Split ( ",", xLong )
							xList_Datab = Regex.Split (",", xDatab)
							
							xCnt_lat = xList_Lat.Size
							Try
								
								Starter.SQL_TTM.BeginTransaction
								For i = 0 To xCnt_lat-1
									xLat = xList_Lat.Get(i)
									xLong = xList_long.Get(i)
									If xList_Datab.Size > i Then
										xDatab = xList_Datab.Get(i)
									End If
									If xList_Som.Size > i Then
										xarq_som = xList_Som.Get(i)
									End If
									Try
										If xLat.Length > 5 Then
											xSql = "Insert into eventos ( cod_mensagem, send_receive,  seq, latitude, longitude, datab, enviado) values ( '" & xCod_Mensagem.Trim & "', 'rec','" & xSeq & "', '" & xLat & "', '" & xLong & "', '" & xDatab & "', 'N' )"
											Starter.SQL_TTM.ExecNonQuery(xSql)
										End If
									Catch
										Log(LastException)
									End Try
								
									'Log ( xSql)
									If xarq_som.Length > 5 Then
										gList_Urls_Voz.Add(xarq_som)
									End If
								Next
								Starter.SQL_TTM.TransactionSuccessful
							Catch
								Log(LastException)
							End Try
							Starter.SQL_TTM.EndTransaction

							xCnt = xCnt + 1
						Loop
#if log
						Log ( "--------" & Main.gTipo_Produto & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
						Log ("Sincronizados: " & xCnt )
						Log ( "-------------------")
#end if		
						If gList_Urls_Voz.Size > 0 And gList_Urls_Voz.Get (0) <> "" Then
							'Download os arquivos de voz
							gCnt_Urls_Voz = 0
							Main.gArq_Download = gList_Urls_Voz.Get(gCnt_Urls_Voz)
							job_evento.Initialize ("mp3", Me)
							xUrl =  gList_Urls_Voz.Get(gCnt_Urls_Voz)
							job_evento.Download ("http://www.consulta10.com.br/ttm/voz_sos/" & xUrl )
							'
							'							job_evento.GetRequest.SetContentType ("audio/mpeg")
							'							job_evento.GetRequest.Timeout = 15000
							'							xUrl =  "http://www.consulta10.com.br/ttm/voz_sos/" & gList_Urls_Voz.Get(gCnt_Urls_Voz)
#if log
							Log ( "* busca som: " & xUrl )
#end if	
				

						End If
					Else
						Msgbox ( xList_Resp.Get(0), trans.translate("Resposta"))
					End If
				Case "Job_Reenvia_Mensagem"
					'				xresp = Job.GetString
#if log
					Log ( "Solicitação de reenvio feita")
#end if			
				Case "fcm"
					Log ( xresp )
				Case "Job_Nao_Autorizado"
					Log ( "Resposta: " & xresp )
			End Select
				
		Catch
			Log(LastException)
			CallSub ( Main, "Some_Progress" )
			Log("Error: " & Job.ErrorMessage)
		End Try

	Else
		'verificar se envio de mensagem ou evento e tentar re-enviar em 0 segundos
		
		ToastMessageShow ( trans.translate("Verifique sua conexão com a Internet"), True)
		Log("Error: " & Job.ErrorMessage)
		xresp = "Error: " & Job.ErrorMessage
		'		Msgbox ( xresp, "Erro Registro")
		'		CallSub2 ( "Main", "Back_Verificacao", xresp )

	End If
	Job.Release
End Sub
