﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Public fm As FirebaseMessaging
	Dim SU As StringUtils
	Dim Timer_beep As Timer
End Sub

Sub Service_Create
	fm.Initialize("fm")
	Timer_beep.Initialize ( "Timer_Beep", 180000)
	Timer_beep.Enabled = False
End Sub

Public Sub SubscribeToTopics
	fm.SubscribeToTopic("general") 'you can subscribe to more topics
	Main.gToken = fm.Token
	Log ( "Token: " & fm.Token )
End Sub

Sub Service_Start (StartingIntent As Intent)
	If StartingIntent.IsInitialized Then fm.HandleIntent(StartingIntent)
	Sleep(0)
	Service.StopAutomaticForeground 'remove if not using B4A v8+.
	

'	If StartingIntent.IsInitialized And fm.HandleIntent(StartingIntent) Then Return
End Sub

Sub Timer_Beep_Tick
	Dim ph As Phone
	Timer_beep.Enabled = False
	Main.MyPlayer1.Stop
	ph.SetVolume(ph.VOLUME_MUSIC,srv_location_firebase.Volume_Atual,False)
	
End Sub
Sub fm_MessageArrived (Message As RemoteMessage)
'	Log("Message arrived")
'	Log($"Message data: ${Message.GetDataData}"$)
'	Dim n As Notification
'	n.Initialize
'	n.Icon = "icon"
'	n.SetInfo(Message.GetData.Get("title"), Message.GetDataData.Get("body"), Main)
'	n.Notify(1)

	Dim ph As Phone
	Dim phv As PhoneVibrate
	
	Dim xTitulo, xMsg, xAcao , xUrl_Voz, xSql, xDatab, xData, xHora, xtelefone, xNome, xLat, xLong, xData, xLats, xLongs, xDatas, xSons, xcod_mensagem As String
	Dim p As Phone
	Dim ln As Notification
	Dim xList_Lat, xList_long, xList_Data, xList_Som  As List
	Dim xCnt As Int
	Dim xFinaliza, xStatus_mensagem, xStatus As String
	Dim xCursor As ResultSet

	Dim xSeq_Eventos, xDados, xUrl, xSenha, xSql_Mens As String
	Dim xFlag_Mens As String
	Dim xCursor_Mens As ResultSet
	
	Main.gFlag_Enviado_COnfirmacao = False  'indica ainda não enviado a confirmação
	Main.gFlag_Ja_Acionou = False
	

'	Main.Volume_Atual = NativeMe.RunMethod("audiovol_get", Null).AsNumber ' Audiovolume_get

	CallSub (Starter,  "Monta_Vatriaveis_Contatos")
'	xTelefones_Emergencia = Starter.Ini_Conf.PutSimple ( "telefones_emergencia", "")
'	xTelefones_Caminho = Starter.Ini_Conf.PutSimple ( "telefones_caminho", "")
'	xTelefones_Seguranca = Starter.Ini_Conf.PutSimple ( "telefones_seguranca", "")
'	xTelefones_Som_Emergencia = Starter.Ini_Conf.PutSimple ( "telefones_som_Emergencia", "")
'	xTelefones_Envia_Localizacao = Starter.Ini_Conf.PutSimple ( "telefones_envia_Localizacao", "")
'	xTelefones_Recebe_Emergencia = Starter.Ini_Conf.PutSimple ( "telefones_recebe_Emergencia", "")
'


	xUrl_Voz =  SU.DecodeUrl(Message.GetData.Get("url_voz"), "UTF8" )
	xTitulo =  SU.DecodeUrl(Message.GetData.Get("title"), "UTF8" )
	xMsg  = SU.DecodeUrl( Message.GetData.Get("message"), "UTF8" )
	xcod_mensagem = Message.GetData.Get("cod_mensagem")
	xtelefone = Message.GetData.Get("telefone")    'telefone de quem  enviou a mensagem
	xAcao = Message.GetData.Get("acao")
	xNome = Message.GetData.Get("nome")
	xStatus_mensagem = Message.GetData.Get("campo1")
	
	If xAcao = "confirma_leitura" Then
		'Salva no banco confirmação de leitura da mensagem enviada para terceiros
		xData = xMsg.SubString2 (4,6) & "/" & xMsg.SubString2 (2,4) & "/" & xMsg.SubString2 (0,2)
		xHora = xMsg.SubString2 (6,8) & ":" & xMsg.SubString2 (8,10) & ":" & xMsg.SubString2 (10,12)
		xSql = "Update mensagens set status ='lida', data_leitura ='" & xData & "', hora_leitura='" & xHora & "', datab_leitura='" & xMsg &  "'  where cod_mensagem ='" & xcod_mensagem & "' "
#if log
		Log ( "--------" & " - " & DateTime.Date( DateTime.Now)  & "------------------" )
		Log ( "Dados: " & xSql )
		Log ( "--------------------------" )
#end if
		Starter.SQL_TTM.ExecNonQuery (xSql)
		'		ln.Initialize(DateTime.Now + 1 * DateTime.TicksPerSecond)
		'		ln.AlertBody = "Confirmação de leitura  - " & xcod_mensagem
		'		ln.PlaySound = False
		'		ln.Register
		Return
	Else
		'Cria entrada da nova mensagem recebido no banco de dados
		DateTime.DateFormat = "dd/MM/yyyy"
		xData = DateTime.Date ( DateTime.Now )
		DateTime.DateFormat = "HH:mm:ss"
		xHora = DateTime.Date ( DateTime.Now )
		DateTime.DateFormat = "yyMMddHHmmss"
		xDatab = DateTime.Date ( DateTime.Now )
		
		If xAcao = "route" Or xAcao ="emergencia" Or xAcao ="seguranca" Then
			'Verificar se já existe se sim atualizar final
			xSql = "Select cod_mensagem from mensagens where cod_mensagem ='" & xcod_mensagem & "'"
			xCursor =Starter.SQL_TTM.ExecQuery(xSql)
			If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim" And Starter.gTelefones_Recebe_Emergencia.Contains( "," & xtelefone) Then
				xFinaliza = "N"
				If xCursor.NextRow  Then
					If xStatus_mensagem = "fim" Then
						xSql = "Update mensagens set data_final = '" & xData & "', hora_final ='" & xHora & "', datab_final ='" & xDatab & "', status ='F' where cod_mensagem='" & xcod_mensagem & "' "
						Starter.Ini_Conf.Remove ( xcod_mensagem)
						xFinaliza = "S"
					End If
				Else
					xStatus = "A"
					If xStatus_mensagem = "fim" Then
						xStatus = "F"
						xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab, data_leitura, hora_leitura, datab_leitura, status, send_receive, tipo_mensagem, data_final, hora_final, datab_final )"
						xSql =xSql & "Values ('" & xcod_mensagem & "','" & xtelefone & "','" & xNome & "', '" & xMsg & "', '" & xDatab & "','" & xData & "','" & xHora & "','" & xDatab  & "','" & xStatus  & "','" & "rec" & "','" & xAcao  & "','" & xData & "','" & xHora & "','" & xDatab  & "' )"
						Starter.Ini_Conf.Remove ( xcod_mensagem)
					Else
						xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab, data_leitura, hora_leitura, datab_leitura, status, send_receive, tipo_mensagem )"
						xSql =xSql & "Values ('" & xcod_mensagem & "','" & xtelefone & "','" & xNome & "', '" & xMsg & "', '" & xDatab & "','" & xData & "','" & xHora & "','" & xDatab  & "','" & xStatus  & "','" & "rec" & "','" & xAcao  & "' )"
						Starter.Ini_Conf.PutSimple( xcod_mensagem, 0)  'inicia a sequencia desta mensagem
					End If
				End If
				Try
					Starter.SQL_TTM.ExecNonQuery ( xSql )
				Catch
					Log(LastException)
				End Try
				Starter.Ini_Conf.PutSimple("cod_mensagem_recebida", xcod_mensagem)
			End If
			CallSub2 (srv_location_firebase, "Envia_Confirmacao", xtelefone )
			If 	Starter.Ini_Conf.GetSimple ( "pnl_black_on", "nao") = "nao" Then
				CallSub2 ( Main,"Monta_Mensagens" , "recebidas" )
			End If
		End If
	End If
#if log 
	Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
	Log($"Message arrived: ${Message}"$)
	Log ( "Ação: "  & xAcao )
	Log ( "--------------------------------------" )
#end if

	DateTime.TimeFormat ="HHmmss"
	Main.gAcao = xAcao
	Starter.Ini_Conf.PutSimple("enviar_posicao", "nao" )

	If xAcao = "localizar" Then
		If Starter.Ini_Conf.GetSimple ("conf_envia_localizacao","sim") = "sim" And Starter.gTelefones_Envia_Localizacao.Contains ( "," & xtelefone)  Then
			Starter.Ini_Conf.PutSimple("alarme_localiza", "sim")   'localizar o aparelho
	'		NativeMe.RunMethod("setAudioSession", Null)
			Main.MyPlayer1.Initialize2("MyPlayEnd")
			Main.MyPlayer1.Load (File.DirAssets, "beep.mp3")
			Main.MyPlayer1.Looping=True
			Main.MyPlayer1.Play
			
			srv_location_firebase.Volume_Atual = ph.GetVolume ( ph.VOLUME_MUSIC )
			ph.SetVolume(ph.VOLUME_MUSIC,ph.GetMaxVolume(ph.VOLUME_MUSIC),False)
			Timer_beep.Enabled = True
		Else
			'Enviar não autorizado
			Enviar_Nao_Autorizado ( xAcao, xcod_mensagem, xtelefone )					
#if Log
Log ( "Não localizado" )
#End If
		End If
	End If

	If xAcao = "posicao" Then
		If Starter.Ini_Conf.GetSimple ("conf_envia_localizacao","sim") = "sim" And Starter.gTelefones_Envia_Localizacao.Contains ( "," & xtelefone)  Then
			Starter.Ini_Conf.PutSimple("enviar_posicao", "sim" )
			Starter.Ini_Conf.PutSimple("telefone_posicao", xtelefone) 	'telefone de quem solicitou
			Starter.Ini_Conf.PutSimple("nome_posicao", xNome) 	'telefone de quem solicitou
			CallSub ( srv_location_firebase, "Location_Start")
		Else
			'Enviar não autorizado
			Enviar_Nao_Autorizado ( xAcao, xcod_mensagem, xtelefone )
		End If
	End If

	If xAcao = "posicao_solicitada" Then
		'volta a posicao solicitada salva em mensagens
		If Starter.Ini_Conf.GetSimple ("conf_envia_localizacao","sim") = "sim" And Starter.gTelefones_Envia_Localizacao.Contains ( "," & xtelefone)  Then
			xLat = Message.GetData.Get("campo1")
			xLong = Message.GetData.Get ("campo2")
			xcod_mensagem = "pos" & xtelefone & xDatab
			xSql = "Insert into mensagens ( cod_mensagem, telefone, nome, texto, datab,  data_envio, hora_envio, datab, data_leitura, hora_leitura, datab_leitura, status, send_receive, tipo_mensagem, data_final, hora_final, datab_final )"
			xSql =xSql & "Values ('" & xcod_mensagem & "','" & xtelefone & "','" & xNome & "', '" & xMsg & "','" & xDatab & "','" & xData & "','" & xHora & "','" & xDatab & "','" & xData & "','" & xHora & "','" & xDatab  & "','" & "F"  & "','" & "send" & "','" & xAcao  & "','" & xData & "','" & xHora & "','" & xDatab  & "' )"
			Try
				Starter.SQL_TTM.ExecNonQuery ( xSql )
			Catch
				Log(LastException)
			End Try
			'criar evento
			xSql = "Insert into eventos ( cod_mensagem, send_receive,  seq, latitude, longitude, datab, enviado) values ( '" & xcod_mensagem.Trim & "', 'send','" & "1" & "', '" & xLat & "', '" & xLong & "', '" & xDatab & "', 'N' )"
			Try
				Starter.SQL_TTM.ExecNonQuery ( xSql )
			Catch
				Log(LastException)
			End Try
		Else
			'Enviar não autorizado
			Enviar_Nao_Autorizado ( xAcao, xcod_mensagem, xtelefone )
		End If
'		Main.Monta_Mensagens ( "enviadas")
'			If Main,.Pagina_Atual <> "main" Then
'				funcoes.Im_Voltar_Padrao_Click
'			End If
	End If

	If xAcao = "emergencia" Then
		If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim" And Starter.gTelefones_Recebe_Emergencia.Contains( "," & xtelefone) Then
			ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
			'	n.Icon = "icon"
			'	n.SetInfo(Message.GetData.Get("title"), Message.GetDataData.Get("body"), Main)
			'	n.Notify(1)

			If xFinaliza = "N" Then
				Starter.Ini_Conf.PutSimple("alarme_localiza", "sim")
				If Starter.Ini_Conf.GetSimple ("conf_som_emergencia","sim") = "sim" And Starter.gTelefones_Som_Emergencia.Contains( "," & xtelefone) Then
'					NativeMe.RunMethod("setAudioSession", Null)
					Main.MyPlayer1.Initialize2("MyPlayEnd")
					Main.MyPlayer1.Load ( File.DirAssets, "sirene.mp3" )
					Main.MyPlayer1.Looping=False
					Main.MyPlayer1.Play
					srv_location_firebase.Volume_Atual = ph.GetVolume ( ph.VOLUME_MUSIC )
					ph.SetVolume(ph.VOLUME_MUSIC, ph.GetMaxVolume(ph.VOLUME_MUSIC),False)
					'ph.SetVolume(1,ph.GetVolume(ph.VOLUME_RING),False)
				End If
				If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
					'verificar se esta em background avisa
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then 	phv.Vibrate (1000)
					ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
					ln.Icon = "icon"
					ln.SetInfo(xAcao, "Mens: "  & xMsg , "Main") 'AlertBody =  "Emergência: " & xMsg
					ln.Sound = True
					ln.AutoCancel = True
					ln.Light = True
					ln.Notify(1)
				Else
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
				End If
			Else
				If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
					'verificar se esta em background avisa
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (1000)
					ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
					ln.Icon = "icon"
					ln.SetInfo(xAcao, "Emergência: Finalizada" , "Main") 'AlertBody =  "Emergência: " & xMsg
					ln.Sound = True
					ln.AutoCancel = True
					ln.Light = True
					ln.Notify(1)
				Else
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
				End If
			End If
		End If
'		If Starter.Ini_Conf.GetSimple ( "tipo_mensagens","") = "recebidas" And Starter.Ini_Conf.GetSimple ("background", "sim") = "nao" Then
'			CallSub2 ( Main, "Monta_Mensagens" , "recebidas" )
'		End If
		'		ln.AlertBody = xTitulo + "\n " +  xMsg
	End If

	If xAcao = "seguranca" Then
		If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim" And Starter.gTelefones_Recebe_Emergencia.Contains( "," & xtelefone) Then
			ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
			If xFinaliza = "N" Then
				Starter.Ini_Conf.PutSimple("alarme_localiza", "sim")
				If Starter.Ini_Conf.GetSimple ("conf_som_emergencia","sim") = "sim" And Starter.gTelefones_Som_Emergencia.Contains( "," & xtelefone) Then
'					NativeMe.RunMethod("setAudioSession", Null)
					Main.MyPlayer1.Initialize2("MyPlayEnd")
					Main.MyPlayer1.Load(File.DirAssets, "sirene.mp3" )
					Main.MyPlayer1.Looping=False
					Main.MyPlayer1.Play
					srv_location_firebase.Volume_Atual = ph.GetVolume ( ph.VOLUME_MUSIC )
					ph.SetVolume(ph.VOLUME_MUSIC, Ph.GetMaxVolume(Ph.VOLUME_MUSIC),False)
'					ph.SetVolume(1,ph.GetVolume(ph.VOLUME_RING),False)
					
				End If
				If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
					'verificar se esta em background avisa
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (1000)
					ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
					ln.Icon = "icon"
					ln.SetInfo(xAcao, "Mens: " & xMsg , "Main") 'AlertBody =  "Emergência: " & xMsg
					ln.Sound = True
					ln.Light = True
					ln.AutoCancel = True
					ln.Notify(1)
				Else
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
				End If

			Else
				If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
					'verificar se esta em background avisa
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (1000)
					ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
					ln.Icon = "icon"
					ln.SetInfo(xAcao, "Segurança: Finalizada" , "Main") 'AlertBody =  "Emergência: " & xMsg
					ln.Sound = True
					ln.Light = True
					ln.AutoCancel = True
					ln.Notify(1)
				Else
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
				End If

			End If
		End If
	End If

	If xAcao = "reenvio_mensagem" Then
		If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim" And Starter.gTelefones_Emergencia.Contains( "," & xtelefone) Then
			'Verificar se já chegou
			xSql = "Select cod_mensagem from mensagens where cod_mensagem ='" & xcod_mensagem & "'"
			xCursor_Mens =Starter.SQL_TTM.ExecQuery(xSql)
			'verifica se já recebeu a mensagem se não socitar eventos e mensagem original
			If xCursor_Mens.NextRow = False Then
				xSeq_Eventos = "0"  'inicia a sequencia desta mensagem
				xtelefone =   Starter.Ini_Conf.GetSimple ( "cod_telefone", "" )
				xSenha = Starter.Ini_Conf.GetSimple ("cod_senha", "")

				xDados =  "comando=sos_busca_eventos&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xcod_mensagem & "&telefone_original=" & xtelefone  & "&senha="  & xSenha
				xDados = xDados & "&seq_evento=" & xSeq_Eventos & "&solicita_mensagem=S"
				xUrl = "http://www.consulta10.com.br/ttm/firebase.php"
	#if log
				Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
				Log ( "Dados: " &  " - " & xDados )
				Log ( "URL: " & xUrl )
				Log ( "--------------------------" )
	#end if		
				srv_location_firebase.job_evento.Initialize ( "Job_Busca_Eventos", srv_location_firebase )
				srv_location_firebase.job_evento.PostString( xUrl, xDados  )
			Else
				Log ( xCursor_Mens.GetString ("cod_mensagem")	)
			End If
		End If
	End If
	
#if log
	Log ("Titulo: " & xAcao & " - Texto: " & xMsg )
#End If
	
	If xAcao = "route" Then
		If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim"  Then
			If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
				'verificar se esta em background avisa
				If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (1000)
				ln.Initialize  '(DateTime.Now + 1 * DateTime.TicksPerSecond)
				ln.Icon = "icon"
				ln.SetInfo("Caminho", "Mens: " & xMsg , "Main") 'AlertBody =  "Emergência: " & xMsg
				ln.Sound = True
				ln.Light = True
				ln.AutoCancel = True
				ln.Notify(1)
			Else
				If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
			End If	
			' salva mensagem no banco de dados
		End If
	End If

	If xAcao = "evento" Then
		If Starter.Ini_Conf.GetSimple ("conf_recebe_emergencia","sim") = "sim"  And Starter.gTelefones_Recebe_Emergencia.Contains( "," & xtelefone)  Then
			If Starter.Ini_Conf.GetSimple ( "vibra_eventos", "sim" ) = "sim" Then
				If Starter.Ini_Conf.GetSimple ("background","nao") = "sim" Then
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (1000)
				Else
					If Starter.Ini_Conf.GetSimple ( "conf_vibra_eventos", "sim" ) = "sim" Then phv.Vibrate (200)
				End If
			End If
			'busca ebentos no servidor
			
			'Verifica se mensagem já chegou se não solicita junto com o evento
			xFlag_Mens = "S"
			xSql_Mens = "Select cod_mensagem from mensagens where cod_mensagem ='" & xcod_mensagem & "'"
			xCursor_Mens = Starter.SQL_TTM.ExecQuery ( xSql_Mens )
			If xCursor_Mens.NextRow Then
				xFlag_Mens = "N"  'indica já recebe o cabeçalho da mensagem
			End If

			xSeq_Eventos = Starter.Ini_Conf.GetSimple ( xcod_mensagem, 0)  'inicia a sequencia desta mensagem
			xtelefone =   Starter.Ini_Conf.GetSimple ( "cod_telefone", "" )
			xSenha = Starter.Ini_Conf.GetSimple ("cod_senha", "")

			xDados =  "comando=sos_busca_eventos&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & xcod_mensagem & "&telefone_original=" & xtelefone  & "&senha="  & xSenha
			xDados = xDados & "&seq_evento=" & xSeq_Eventos & "&solicita_mensagem=" & xFlag_Mens
			xUrl = "http://www.consulta10.com.br/ttm/firebase.php"
	#if log
			Log ( "--------" &  " - " & DateTime.Date( DateTime.Now)  & "------------------" )
			Log ( "Dados: " &  " - " & xDados )
			Log ( "URL: " & xUrl )
			Log ( "--------------------------" )
	#end if	
			srv_location_firebase.job_evento.Initialize ( "Job_Busca_Eventos", srv_location_firebase )
			srv_location_firebase.job_evento.PostString( xUrl, xDados  )
		End If
	End If
	
	If xAcao = "posicao_nao_autorizada" Then
		ToastMessageShow ( trans.translate("Posicao solicitada não autorizada"), True)
		srv_location_firebase.Volume_Atual = ph.GetVolume ( ph.VOLUME_MUSIC )
		Main.MyPlayer1.Initialize2("MyPlayEnd")
		Main.MyPlayer1.Load (File.DirAssets, "beep.mp3")
		Main.MyPlayer1.Looping=False
		Main.MyPlayer1.Play
		
	End If
	If xAcao = "localizar_nao_autorizado" Then
		ToastMessageShow ( trans.translate("Localização solicitada não autorizada"), True)
		srv_location_firebase.Volume_Atual = ph.GetVolume ( ph.VOLUME_MUSIC )
		Main.MyPlayer1.Initialize2("MyPlayEnd")
		Main.MyPlayer1.Load (File.DirAssets, "beep.mp3")
		Main.MyPlayer1.Looping=False
		Main.MyPlayer1.Play
		
	End If

End Sub

Sub Service_Destroy

End Sub

Sub MyPlayEnd_Complete
	Dim ph As Phone
	ph.SetVolume(ph.VOLUME_MUSIC ,srv_location_firebase.Volume_Atual,False)
'	ph.SetVolume(srv_location_firebase.Volume_Atual ,ph.GetVolume(ph.VOLUME_RING),False)

End Sub


Sub Enviar_Nao_Autorizado ( pAcao As String, pCod_Mensagem As String, pTelefone As String )
	
	Dim xTelefone, xNome, xSenha,  xdados, xURL, xDatab, xComando As String
	xTelefone = Starter.Ini_Conf.GetSimple ( "cod_telefone", "")
	xNome = Starter.Ini_Conf.GetSimple ("cod_nome","")
	xSenha = Starter.Ini_Conf.GetSimple ( "cod_senha","")

	Select pAcao
		Case "posicao"
			xComando = "sos_posicao_nao_autorizada"
		Case "localizar"
			xComando = "sos_localizar_nao_autorizado"
	End Select
	xdados =  "comando=" & xComando &"&distribuidor=1"& "&aplicativo=sos" & "&cod_mensagem=" & pCod_Mensagem & "&telefone_original=" & xTelefone  & "&senha="  & xSenha & "&nome=" & xNome
	xdados = xdados  & "&telefone_destino=" & pTelefone & "&datab=" & xDatab
	xURL = "http://www.consulta10.com.br/ttm/firebase.php"
	srv_location_firebase.job_evento.Initialize ( "Job_Nao_Autorizado", srv_location_firebase )
	srv_location_firebase.job_evento.PostString( xURL, xdados  )

End Sub